<link rel="stylesheet" type="text/css" href="/m/private-instant-book-mobile.css?v="<?= CSS_STATIC_V ?> />
<script>
	var i18nStartTime = "<?= __('start_time'); ?>",
		i18nDuration = "<?= __('duration'); ?>",
		i18nLocation = "<?= __('location'); ?>",
		i18nOutcallAddress = "<?= __('outcall_address'); ?>",
		i18nSpecialRequest = "<?= __('special_request'); ?>",
		i18nPhone = "<?= __('phone'); ?>",
		i18nContactType = "<?= __('contact_type'); ?>",
		i18nTimeLeft = "<?= __('time_left'); ?>",
		i18nStatus = "<?= __('status'); ?>";
</script>

<div class="IBHistory inpStyle">
	<a href="#" class="IBHistory__filterToggler">
		<?= __('filter'); ?>
	</a>
	<div class="IBHistory__container--filters">
		<div class="IBHistory__filters">
			<div class="IBHistory__filterInputs">
				<div class="input-wrapper">
					<input type="text" placeholder="<?= __('start_date'); ?>" class="input--text" id="dateFrom" onfocus="(this.type='date')" onblur="(this.type='text')" />
				</div>
				<div class="input-wrapper">
					<input type="text" placeholder="<?= __('end_date'); ?>" class="input--text" id="dateTo" onfocus="(this.type='date')" onblur="(this.type='text')"/>
				</div>
			</div>
			<div class="IBHistory__CTABtns">
				<a href="#" class="FilterBtn" id="filterBtn">
					<i class="icon--filter"></i>
					<?= __('search'); ?>
				</a>
				<a href="#" class="ResetBtn" id="resetBtn">
					<i class="icon--reset"></i>
				</a>
			</div>
		</div>
	</div>
	<div class="IBHistory__grid" id="grid">
		
	</div>
</div>

<script>
	(function(window) {
		function InstantCountDown(params) {
			return this.init(params);
		}

		InstantCountDown.prototype = {
			init: function(params) {
				this.params = params || {};

				this.build();
			},

			build: function() {
				if (!this.params.$el) return false;

				var
					_hours = this.params.timer.h || 0,
					_minutes = this.params.timer.m || 0,
					_seconds = this.params.timer.s || 0;

				this.timeInMs = (_hours * 60 * 60 * 1000) + (_minutes * 60 * 1000) + (_seconds * 1000);
			},

			start: function() {
				var _self = this;

				this.countDownTimer = setInterval(function() {
					if (_self.timeInMs <= 0) {
						_self.params.timeUpCallback && _self.params.timeUpCallback();
						_self.stop();
					}
					_self.timeInMs -= 1000;

					var html = _self._decorateHtml();

					_self._draw(html);
				}, 1000);
			},

			stop: function() {
				clearInterval(this.countDownTimer);
			},

			_decorateHtml: function() {
				var _hours = 0
				, _minutes = 0
				, _seconds = 0
				, _rem = this.timeInMs;
				_hours = Math.floor(_rem / (60 * 60 * 1000));
				
				if (_hours) _rem = _rem % (60 * 60 * 1000);
				_minutes = Math.floor(_rem / (60 * 1000));
				
				if (_minutes) _rem = _rem % (60 * 1000);
				_seconds = Math.floor(_rem / (1000));

				var html = '';

				if (_hours) {
				html += '<span class="Countdown__hours">'+ ('0' + _hours).slice(-2) + '</span>';
				}

				if (_hours) {
					html += ':';
				}

				html += '<span class="Countdown__minutes">' +  ('0' + _minutes).slice(-2) + '</span>';
				html += ':';
				html += '<span class="Countdown__seconds">' + ('0' + _seconds).slice(-2) + '</span>';

				if (this.params.customText) {
				html = this.params.customText.replace('%COUNTDOWN%', html);
				}

				return html;
			},

			_draw: function(html) {
				this.params.$el.html(html);
			}
		};

		function IBHistory() {}

		IBHistory.prototype = {
			init: function ($container) {
				var _self = this;

				this.$container = $container;
				this.$dateFrom = $container.find('#dateFrom');
				this.$dateTo = $container.find('#dateTo');
				this.$filterBtn = $container.find('#filterBtn');
				this.$filterBtn.on('click', function () {
					_self.build();
				});

				this.$resetBtn = $container.find('#resetBtn');
				this.$resetBtn.on('click', function () {
					_self.state = {
						page: 1
					};
					_self.build();
				})

				this.$historyContent = $container.find('#IBHistoryContent');
				this.$paging = $container.find('#IBHistoryPaging');

				this.state = {
					page: 1,
					date_from: null,
					date_to: null
				};

				this.build();
			},

			setState: function (obj) {
				var _self = this;

				$.each(obj, function (value, key) {
					_self.state[key] = value;
				});

				this.build();
			},

			build: function (fromDb) {
				var fd = (typeof fromDb === 'undefined') ? true : fromDb;
				var _self = this;

				if (fd) {
					this.getData(this.state, function () {
						_self._draw();
						_self._bindEvents();
						_self._startCountDown();
					});
				} else {
					_self._draw();
					_self._bindEvents();
					_self._startCountDown();
				}

				return this;
			},

			getData: function (reqObject, callback) {
				var _self = this;

				$.ajax({
					url: '/private-v2/instant-book-history',
					method: 'POST',
					data: reqObject,
					dataType: 'json',
					success: function (resp) {
						_self.data = resp;
						callback();
					}
				});
			},

			_bindEvents: function () {
				var _self = this;

				this.$paging.find('.page').off('click').on('click', function () {
					_self.setState({
						page: +this.data('page')
					});
				});

				this.$container.find('.IBHistory__cardItem--actionButton-2').on('click', function () {
					if (typeof instantSocket === 'undefined') return false;

					var $btn = $(this);
					$btn.addClass('is-loading');

					instantSocket.emit('booking_request_reply', {
						status: 'deny',
						token: $btn.data('token'),
						id: $btn.data('id')
					});
					
					setTimeout(function() {
						$btn.removeClass('is-loading');
						window.location.reload();
					}, 100);
				});

				this.$container.find('.IBHistory__cardItem--actionButton-1').off('click').on('click', function () {
					if (typeof instantSocket === 'undefined') return false;

					var $btn = $(this);
					$btn.addClass('is-loading');

					instantSocket.emit('booking_request_reply', {
						status: 'accept',
						token: $btn.data('token'),
						id: $btn.data('id')
					});

					setTimeout(function() {
						$btn.removeClass('is-loading');
						window.location.reload();
					}, 100);
				});

				var $document = $(document);/*,
                    lastElementY = $('.IBHistory__card').offset().top;

				$document.on('scroll', function() {
					if ($document.scrollTop() >= lastElementY) {
						
					}
				});*/

				this.$container.find('.IBHistory__card:not(.deny):not(.no_answer)  .IBHistory__card-main').on('click', function() {
					var $el = $(this);

					if ($el.hasClass('open')) {
						$(this).removeClass('open');
						$(this).next('.IBHistory__card-details').removeClass('open');
					} else {
						$(this).addClass('open');
						$(this).next('.IBHistory__card-details').addClass('open');
					}
				});

				$('.IBHistory__filterToggler').off('click').on('click', function() {
					var $el = $(this);

					if ($el.hasClass('open')) {
						$(this).removeClass('open');
					} else {
						$(this).addClass('open');
					}
				});

				return this;
			},

			_setData: function (data) {
				$.ajax({}).send();
			},

			_getDecorated: function(data) {
				if (data.status === 'pending') {
					var _hours = 0
						, _minutes = 0
						, _seconds = 0
						, _rem = new Date(data.wait_time).getTime() + 60 * 60 * 1000 - new Date().getTime();

					_hours = Math.floor(_rem / (60 * 60 * 1000));

					if (_hours) _rem = _rem % (60 * 60 * 1000);
					_minutes = Math.floor(_rem / (60 * 1000));

					if (_minutes) _rem = _rem % (60 * 1000);
					_seconds = Math.floor(_rem / (1000));

					var timeLeft = '<span class="time-left" data-h="' + _hours + '" data-m="' + _minutes + '" data-s="' + _seconds +
						'"></span>';
				}

				var _status = '';

				switch (data.status) {
					case 'accept':
						_status = 'ACCEPT';
						break;
					case 'deny':
						_status = 'DENIED';
						break;
					case 'no_answer':
						_status = 'NO ANSWER';
						break;
				}

				var _requestDate = new Date(data.request_date * 1000);
				var _requestDateStr = ('0' + _requestDate.getDate()).slice(-2) + '-'
					+ (('0' + (_requestDate.getMonth() + 1))).slice(-2) + '-'
					+ _requestDate.getFullYear();

				var html = '<div class="IBHistory__card ' + data.status + '">'
						+ '<div class="IBHistory__card-main">'
							+ '<div class="IBHistory__cardItem--title">'
								+ '<span class="IBHistory__cardItem--primaryTitle">' + data.location + ' at ' + data.start_time + ' ' + _requestDateStr + '</span>'
								+ '<span class="IBHistory__cardItem--secondaryTitle">' + ((data.status === 'pending') ? timeLeft : _status) + '</span>'
							+ '</div>'
						+ '</div>'
						+ '<div class="IBHistory__card-details">'
							+ '<div class="IBHistory__cardItem--body">'
								+ '<p>Special Request:</p>' + (data.special_request ? data.special_request: '(no special request)')
							+ '</div>'
							+ '<div class="IBHistory__cardItem--actionButtons">'
								+ '<button tabindex="0" type="button" data-id="' + data.id + '" data-token="' + data.hash + '" class="IBHistory__cardItem--actionButton-1">'
									+ '<div>'
										+ '<span class="IBHistory__cardItem--actionButton-1-inner">ACCEPT</span>'
									+ '</div>'
								+ '</button>'
								+ '<button tabindex="1" type="button" data-id="' + data.id + '" data-token="' + data.hash + '"  class="IBHistory__cardItem--actionButton-2">'
									+ '<div>'
										+ '<span class="IBHistory__cardItem--actionButton-2-inner">DENY</span>'
									+ '</div>'
								+ '</button>'
								+ '<button tabindex="2" type="button" class="IBHistory__cardItem--actionButton-3">'
									+ '<div>'
										+ data.contact_type.split(',').map(function(el) { return '<span title="' + el.replace('_', ' ').toUpperCase() + '" class="contact-type ' + el + '"></span>' }).toString().replace(',', '')
										+ '<span class="IBHistory__cardItem--actionButton-3-inner"><a href="tel:' 
										+ (data.phone ? data.phone : '') + '">' + (data.phone ? data.phone : '') +  '</a></span>'
									+ '</div>'
								+ '</button>'
							+ '</div>'
						+ '</div>'
					+ '</div>'
					return $(html);
			},

			_draw: function () {
				var entities = this.data.entities
					, count = this.data.count
					, _self = this;

				/* table content html */
				var contentHtml = '';

				$.each(entities, function (idx, el) {
					_self.$container.append(_self._getDecorated(el));
				});

				/* table paging html */
				var perPage = 10,
					pagingHtml = '',
					pageCount = Math.ceil(count / perPage);

				for (var i = 1; i <= pageCount; i++) {
					pagingHtml += '<a href="#" class="page ' + ((this.state.page === i) ? 'active' : '') + '" data-page="' + i +
						'">' + i + '</i>';
				}
			},

			_startCountDown: function () {
				this.$container.find('.time-left').each(function () {
					var $el = $(this);
					timerData = {
						h: parseInt($el.data('h')),
						m: parseInt($el.data('m')),
						s: parseInt($el.data('s'))
					};

					var timer = new InstantCountDown({
						$el: $el,
						timer: timerData,
						timeUpCallback: function () {
							// window.location.reload();
						}
					});

					timer.start();
				});
			}
		};

		var history = new IBHistory()
			, $container = $('#grid');

		history.init($container);

	})(this);
</script>